"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = exports.ChannelType = void 0;
var hidClient_1 = require("./hid/client/hidClient");
var hidChannel_1 = require("./hid/client/hidChannel");
var tcpClient_1 = require("./tcp/client/tcpClient");
var tcpChannel_1 = require("./tcp/client/tcpChannel");
var serialClient_1 = require("./serialPort/client/serialClient");
var serialChannel_1 = require("./serialPort/client/serialChannel");
var udpClient_1 = require("./udp/client/udpClient");
var udpChannel_1 = require("./udp/client/udpChannel");
var webSocketClient_1 = require("./webSocket/client/webSocketClient");
var webSocketChannel_1 = require("./webSocket/client/webSocketChannel");
var ChannelType;
(function (ChannelType) {
    ChannelType[ChannelType["Hid"] = 0] = "Hid";
    ChannelType[ChannelType["Serial"] = 1] = "Serial";
    ChannelType[ChannelType["Tcp"] = 2] = "Tcp";
    ChannelType[ChannelType["Udp"] = 3] = "Udp";
    ChannelType[ChannelType["WebSocket"] = 4] = "WebSocket";
})(ChannelType = exports.ChannelType || (exports.ChannelType = {}));
var Config = /** @class */ (function () {
    function Config() {
    }
    Config.getClientOptions = function (channelType) {
        return this.values.get(channelType);
    };
    Config.values = new Map([
        [ChannelType.Hid, {
                session: hidClient_1.HidClient,
                channel: hidChannel_1.HidChannel
            }],
        [ChannelType.Tcp, {
                session: tcpClient_1.TcpClient,
                channel: tcpChannel_1.TcpChannel
            }],
        [ChannelType.Serial, {
                session: serialClient_1.SerialClient,
                channel: serialChannel_1.SerialChannel
            }],
        [ChannelType.WebSocket, {
                session: webSocketClient_1.WebSocketClient,
                channel: webSocketChannel_1.WebSocketChannel
            }],
        [ChannelType.Udp, {
                session: udpClient_1.UdpClient,
                channel: udpChannel_1.UdpChannel
            }]
    ]);
    return Config;
}());
exports.Config = Config;
//# sourceMappingURL=config.js.map